clear all;

% open .mat file
name = 'results_potRL_newRLT_10';
load([name '.mat']);

%%
%------------------Analysis----------------------------------------------
slides_=[slidesFirst,out];
fprintf('%g simulated days\n',9+length(out));

infectedLength=zeros(1,size(slides_,2));
allLength = zeros(1,size(slides_,2));
percentInfected = zeros(1,size(slides_,2));

t = [(0.2:0.2:9),((1:length(out))+9)];
fprintf('Evalutaing hld over %g time steps: ',length(t));
for i=1:size(slides_,2)
   fprintf('*%g',t(i));
   str = slides_{i};
   [x1,x2,r1,colors,time,type,ind]=getSegments(str);
   infectedLength(i) = sum(((str(ind,1)==1 & str(ind,5)<100)&(str(ind,6)>0)).*str(ind,3));
   hl(i) = sum(((str(ind,1)==1 & str(ind,5)>100)).*str(ind,3));
   allLength(i) = sum((str(ind,1)==1 & str(ind,5)<100).*str(ind,3));
   percentInfected(i) = (infectedLength)/allLength;
   clear str;
end
fprintf('\n');

%%
% Plots and movies
fprintf('plotting figures\n');
data= readtable([pwd '\Simulation results\data.xlsx'],'sheet','data');

figure
[ax,p1,p2] = plotyy(t,allLength,t,percentInfected.*100);
set(p1,'linewidth',2)% to change the first line
set(p2,'linewidth',2) % to change the second line
xlabel('time (d)','Fontsize',20);
ylabel(ax(1),'RL (cm)','Fontsize',20) % label left y-axis
ylabel(ax(2),'% RL infected','Fontsize',20) % label right y-axis
%savefig('RL')

subplot(1,3,1)
errorbar(data.t-30,data.gesWL./100,data.stabw_1./100,'ko');
hold on
plot(t,allLength./100,'k-','Linewidth',2)
xlabel('time (d)','Fontsize',20);
ylabel('RL (m)','Fontsize',20) 
axis([-2 60 -0.05 23])

subplot(1,3,2)
errorbar(data.t-30,data.x_Col,data.stabw,'ko');
hold on
plot(t,percentInfected*100,'k-','Linewidth',2);
xlabel('time (d)','Fontsize',20);
ylabel('% RL infected','Fontsize',20) 
axis([-2 60 -5 90])
%savefig('percentInfected')
% 
subplot(1,3,3)
plot(t,hl/100/525,'Linewidth',2);
hold on
errorbar(data.t-30,data.HLD,data.stdhld,'ko');subplot
xlabel('time (d)','Fontsize',20);
ylabel('HLD (m/g)','Fontsize',20) 
axis([-2 60 0 3])
%savefig('HLD')

figure
plotLines(x1,x2,r1,colors)
view(3);
%plotTubes(str);
% % savefig('tubes')


clear('slides_');
clear('out_');
clear('out');
clear('slides');
clear('str');
save([name 'analysis.mat']);


% % % plot tta
% % p = tta{end};
% % for i = 1 : size(p,1)
% %     X = [p(i,1), p(i,4)];
% %     Y = [p(i,2), p(i,5)];
% %     Z = [p(i,3), p(i,6)];
% %     %disp(sqrt((X(2)-X(1))^2+(Y(1)-Y(2))^2+(Z(1)-Z(2))^2));
% %     line(X,Y,Z,'Color',[0,0,1]);
% % end
% % 
% % 
% % % plot tta
% % p = tea{end};
% % for i = 1 : size(p,1)
% %     X = [p(i,1), p(i,4)];
% %     Y = [p(i,2), p(i,5)];
% %     Z = [p(i,3), p(i,6)];
% %     %disp(sqrt((X(2)-X(1))^2+(Y(1)-Y(2))^2+(Z(1)-Z(2))^2));
% %     line(X,Y,Z,'Color',[0,1,0]);
% % end
% 

% Movie
% 
% fview = @(frame) axis([-5,5,-5,5,-20,0]);
% makeMovie('mycsim1.avi',slides,simtime,10,fview); 











