%========================================================================
% Automatically generated by Dicot.m: 
% Modify this file to describe root-soil interactions
%========================================================================

p = cell(4,1);

%-----------------------------------------
% Tap root
%-----------------------------------------

% Parameters editable by the GUI [mean, sd]
p{1}.r = [3, 0]; % Initial elongation rate (cm/day)
p{1}.a = [0.1, 0]; % Root radius (cm)  
p{1}.theta = [0.872665, 0]; % Insertion angle(rad)
p{1}.lb = [2, 0]; % Length of basal zone (cm)        
p{1}.la = [7, 0]; % Length of apical zone (cm)                    
p{1}.ln = [1, 0]; % Length between laterals (cm)
p{1}.nob = [30, 0]; % Maximal number of laterals (1)

% Additional parameters (predefined values, not altered by GUI)
p{1}.name = 'Tap root'; % Name of the root type
p{1}.color = [1, 0, 0]; % Color of the root (rgb)
type = 1; % Type of tropism (0 plagio-, 1 gravi-, 2 exo-, 3 chemo-/hydrotropism)
N = 1.5; % Strength of tropism
sigma = 0.2; % Expected change of root tip heading (rad/cm)
p{1}.tropism = [type, N, sigma]; % Root tropism
p{1}.dx = 0.25; % Spatial resolution along root axis (cm)
p{1}.rlt = [Inf, 0]; % Maximal root life time [mean, std] (days)
p{1}.gf = 1; % Type of growth function (1: negative exponential, 2: linear)

% Preset by GUI 
p{1}.successor = [2, 1]; % Laterals [type,probability;type,probability;...]
p{1}.ief = @(x) 1; % impede elongation function: scales root elongation
p{1}.ibf = @(x) 1; % impede branching function: scales branching probability 
p{1}.irlf = @(x) 1; % impede root life: scales root age regarding root life time

%-----------------------------------------
% Laterals 
%-----------------------------------------

% Parameters editable by the GUI [mean, sd]
p{2}.r = [1.3, 0]; % Initial elongation rate (cm/day)
p{2}.a = [0.05, 0]; % Root radius (cm)  
p{2}.theta = [1.22173, 0]; % Insertion angle (rad)
p{2}.lb = [2, 0]; % Length of basal zone (cm)        
p{2}.la = [3, 0]; % Length of apical zone (cm)                    
p{2}.ln = [0.5, 0]; % Length between laterals (cm)
p{2}.nob = [7, 0]; % Maximal number of laterals (1)

% Additional parameters (predefined values)
p{2}.name = 'Lateral'; % Name of the root type
p{2}.color = [0, 1, 0]; % Color of the root (rgb)
type = 1; % Type of tropism (0 plagio-, 1 gravi-, 2 exo-, 3 chemo-/hydrotropism)
N = 1; % Strength of tropism
sigma = 0.3; % Expected change of root tip heading (rad/cm)
p{2}.tropism = [type, N, sigma]; % Root tropism
p{2}.dx = 0.25; % Spatial resolution along root axis (cm)
p{2}.rlt = [Inf, 0]; % Maximal root life time [mean, std] (days)
p{2}.gf = 1; % Type of growth function (1: negative exponential, 2: linear)

% Preset by GUI 
p{2}.successor = [3, 1]; % Laterals [type,probability;type,probability;...]
p{2}.ief = @(x) 1; % impede elongation function: scales root elongation
p{2}.ibf = @(x) 1; % impede branching function: scales branching probability 
p{2}.irlf = @(x) 1; % impede root life: scales root age regarding root life time

%-----------------------------------------
% Second order laterals
%-----------------------------------------

% Parameters editable by the GUI
p{3}.r = [0.7, 0]; % Initial elongation rate (cm/day)
p{3}.a = [0.03, 0]; % Root radius (cm)  
p{3}.theta = [1.22173, 0]; % Insertion angle (rad)
p{3}.la = [1, 0]; % Length of root (cm)                    

% Additional parameters (predefined values)
p{3}.lb = [0, 0]; % Length of basal zone (cm)        
p{3}.ln = [0, 0]; % Length between laterals (cm)
p{3}.nob = [0, 0]; % Maximal number of laterals (1)
p{3}.name = 'Second order lateral'; % Name of the root type
p{3}.color = [0.5, 0.5, 0]; % Color of the root (rgb)
type = 1; % Type of tropism (0 plagio-, 1 gravi-, 2 exo-, 3 chemo-/hydrotropism)
N = 0; % Strength of tropism
sigma = 0.4; % Expected change of root tip heading (rad/cm)
p{3}.tropism = [type, N, sigma]; % Root tropism
p{3}.dx = 0.25; % Spatial resolution along root axis (cm)
p{3}.rlt = [Inf, 0]; % Maximal root life time [mean, std] (days)
p{3}.gf = 1; % Type of growth function (1: negative exponential, 2: linear)

% Preset by GUI 
p{3}.successor = [3, 1]; % Laterals [type,probability;type,probability;...]
p{3}.ief = @(x) 1; % impede elongation function: scales root elongation
p{3}.ibf = @(x) 1; % impede branching function: scales branching probability 
p{3}.irlf = @(x) 1; % impede root life: scales root age regarding root life time

% -----------------------------------------
% Basal roots
% -----------------------------------------

% Parameters editable by the GUI [mean, sd]
p{4}.r = [3, 0]; % Initial elongation rate (cm/day)
p{4}.a = [0.1, 0]; % Root radius (cm)  
p{4}.theta = [1.309, 0]; % Insertion angle (rad)
p{4}.lb = [2, 0]; % Length of basal zone (cm)        
p{4}.la = [15, 0]; % Length of apical zone (cm)                    
p{4}.ln = [1, 0]; % Length between laterals (cm)
p{4}.nob = [30, 0]; % Maximal number of laterals (1)

% Additional parameters (predefined values)
p{4}.name = 'Basal root'; % Name of the root type
p{4}.color = [0.5, 0, 0.5]; % Color of the root (rgb)
type = 1; % Type of tropism (0 plagio-, 1 gravi-, 2 exo-, 3 chemo-/hydrotropism)
N = 1.5; % Strength of tropism
sigma = 0.15; % Expected change of root tip heading (rad/cm)
p{4}.tropism = [type, N, sigma]; % Root tropism
p{4}.dx = 0.25; % Spatial resolution along root axis (cm)
p{4}.rlt = [Inf, 0]; % Maximal root life time [mean, std] (days)
p{4}.gf = 1; % Type of growth function (1: negative exponential, 2: linear)

% Preset by GUI 
p{4}.successor = [2, 1]; % Laterals [type,probability;type,probability;...]
p{4}.ief = @(x) 1; % impede elongation function: scales root elongation
p{4}.ibf = @(x) 1; % impede branching function: scales branching probability 
p{4}.irlf = @(x) 1; % impede root life: scales root age regarding root life time

% -----------------------------------------
% Shoot borne roots
% -----------------------------------------

% Parameters editable by the GUI [mean, sd]
p{5}.r = [3, 0]; % Initial elongation rate (cm/day)
p{5}.a = [0.1, 0]; % Root radius (cm)  
p{5}.theta = [1.39626, 0]; % Insertion angle (rad)
p{5}.lb = [2, 0]; % Length of basal zone (cm)        
p{5}.la = [15, 0]; % Length of apical zone (cm)                    
p{5}.ln = [1, 0]; % Length between laterals (cm)
p{5}.nob = [30, 0]; % Maximal number of laterals (1)

% Additional parameters (predefined values)
p{5}.name = 'Shoot borne root'; % Name of the root type
p{5}.color = [0, 0.5, 0.5]; % Color of the root (rgb)
type = 1; % Type of tropism (0 plagio-, 1 gravi-, 2 exo-, 3 chemo-/hydrotropism)
N = 1; % Strength of tropism
sigma = 0.1; % Expected change of root tip heading (rad/cm)
p{5}.tropism = [type, N, sigma]; % Root tropism
p{5}.dx = 0.25; % Spatial resolution along root axis (cm)
p{5}.rlt = [Inf, 0]; % Maximal root life time [mean, std] (days)
p{5}.gf = 1; % Type of growth function (1: negative exponential, 2: linear)

% Preset by GUI 
p{5}.successor = [2, 1]; % Laterals [type,probability;type,probability;...]
p{5}.ief = @(x) 1; % impede elongation function: scales root elongation
p{5}.ibf = @(x) 1; % impede branching function: scales branching probability 
p{5}.irlf = @(x) 1; % impede root life: scales root age regarding root life time

%-----------------------------------------
% Monocot plant data (editable by the GUI)
%-----------------------------------------

plantingdepth = 3; % (cm)

% Basal roots
basal_first = [0.5, 0]; % First occurence [mean, std] (days)
basal_delay = [2, 0]; % Interim time [mean, std] (days)
basal_max = 5; % Maximal number of basal roots (1)

% Shoot borne roots
sb_first = [7, 0]; % Emergence time of first shoot borne root (days)
sb_delay = [3, 0]; % Time delay between the emergence of shoot borne roots (days)
sb_nCR = [5, 0]; % Number of shoot borne roots per root crown (1)
sb_delayRC = [33, 0]; % Time delay between the emergence of root crowns (days)
sb_dzRC = [1, 0]; % Distance between root crowns along the shoot (cm)

%-----------------------------------------
% Simulation
%-----------------------------------------

% Parameters (editable by the GUI)
simtime = 20;  % simulation time (days)
dt = 20; % temporal resolution, simtime/(intermediate+1) (days) 

% Initialize
p = completeParameters(p); % it is possible to add a container geometry, see completeParameters  
set(0,'RecursionLimit',5000); % sometimes needed
str0 = createMonocotRS(plantingdepth,basal_first,basal_delay,basal_max,0.1,...
                sb_first,sb_delay,sb_nCR,sb_delayRC,sb_dzRC); % create initial string

p{5}.theta = 0;  % shootborne roots angle is already set in createMonocotRS
completeParameters(p); 

N = round(simtime/dt); % number of iterations

for j = 1 : 9
    
    str = str0;
    
    fprintf('number %g\n',j);
    
% Run simulation
for i = 1 : N

    str = applyRules(str,dt); % l-system string representing the root system

    %------------------------------------------------------------
    % execute soil model 
    % dependent on the root system (str) at simulation time i*dt
    % see also: getDensity, getSegments, getTotal
    %------------------------------------------------------------
               
    %
    % plant soil interaction takes place using global variables
    %
    % 1. Root tropism (global variables X,Y,Z,C)
    % 2. Impede elongation (function handle ief)
    % 3. Impede branching (function handle ibf)
    % 4. Impede root life time (function handle irlf)
    %
    

end
    res{j} = str; % save intermediate results
    figure;
    plotTubes(res{j});

end





% %-----------------------------------------
% % Example evaluation (uncomment and run)
% %-----------------------------------------
%
% v = zeros();
% for i = 1 : N
%     v(i) = getTotal(res{i},'l'); % or 's' for surface, see getTotal
% end
% figure;
% plot((1:N).*dt,v);
% xlabel('Time (days)');
% ylabel('Root system length (cm)'); 


